<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of certForm
 *
 * @author INBS38
 */
class certForm
{
    protected $input;
    protected $form;
    protected $fieldErorrs;
    protected $params;
    protected $SSLProducts;

    function __construct($input, $form, $fieldErorrs, $params = null)
    {
        $this->input       = $input;
        $this->form        = $form;
        $this->fieldErorrs = $fieldErorrs;
        $this->params      = $params;
        $this->SSLProducts = $SSLProducts;
    }

    function getForm()
    {
        $this->form->addField('Text', array(
            'name' => 'order_token',
            'value' => $this->input['cert_order_token'],
            'readonly' => true
        ));

        //TO DO Multiselect
        if ($this->params['maxDomains'] == 1) {
            $this->form->addField('Select', array(
                'name' => 'domain',
                'options' => $this->params['domainList']
            ));
        } else {
            $this->form->addField('MultiSelect',
                array(
                'name' => 'domain',
                'options' => $this->params['domainList'],
                'customParams' => array('maxDomains' => $this->params['maxDomains'])
            ));
        }


        $this->form->addField('Legend', array(
            'name' => 'certdetails'
        ));


        $SSLProducts    = new SSLProducts();
        $productsFields = $SSLProducts->productsFields;
        $productFields  = $productsFields[$this->params['productType']];
        $fields         = $SSLProducts->fields;

        if (!empty($productFields)) {
            $require = false;
            foreach ($productFields as $productFieldShortcut => $productFieldStatus) {

                $fieldParams = $fields[$productFieldShortcut];

                if ($productFieldStatus == 'required') {
                    $require = true;
                } else {
                    $require = false;
                }

                if ($fieldParams['name'] == 'country') {
                    $this->form->addField('Select',
                        array(
                        'name' => 'certdetails_'.$fieldParams['name'],
                        'value' => isset($this->input['cert_certdetails_'.$fieldParams['name']]) ? $this->input['cert_certdetails_'.$fieldParams['name']] : null,
                        'options' => CertumSSLCertificate::getCountries(),
                        'error' => (!empty($this->fieldErorrs['cert_certdetails_'.$fieldParams['name']])),
                        'require' => $require
                    ));
                } else {
                    $this->form->addField('Text',
                        array(
                        'name' => 'certdetails_'.$fieldParams['name'],
                        'value' => isset($this->input['cert_certdetails_'.$fieldParams['name']]) ? $this->input['cert_certdetails_'.$fieldParams['name']] : null,
                        'error' => (!empty($this->fieldErorrs['cert_certdetails_'.$fieldParams['name']])),
                        'require' => $require
                    ));
                }
            }
        }


        $this->form->addField('Legend', array(
            'name' => 'contact'
        ));

        $this->form->addField('Text',
            array(
            'name' => 'contact_firstname',
            'value' => isset($this->input['cert_contact_firstname']) ? $this->input['cert_contact_firstname'] : null,
            'error' => (!empty($this->fieldErorrs['cert_contact_firstname'])),
            'require' => true
        ));

        $this->form->addField('Text',
            array(
            'name' => 'contact_lastname',
            'value' => isset($this->input['cert_contact_lastname']) ? $this->input['cert_contact_lastname'] : null,
            'error' => (!empty($this->fieldErorrs['cert_contact_lastname'])),
            'require' => true
        ));

        $this->form->addField('Text',
            array(
            'name' => 'contact_address',
            'value' => isset($this->input['cert_contact_address']) ? $this->input['cert_contact_address'] : null,
            'error' => (!empty($this->fieldErorrs['cert_contact_address'])),
            'require' => true
        ));

        $this->form->addField('Select',
            array(
            'name' => 'contact_country',
            'value' => isset($this->input['cert_contact_country']) ? $this->input['cert_contact_country'] : null,
            'options' => CertumSSLCertificate::getCountries(),
            'error' => (!empty($this->fieldErorrs['cert_contact_country'])),
            'require' => true
        ));

        $this->form->addField('Text',
            array(
            'name' => 'contact_city',
            'value' => isset($this->input['cert_contact_city']) ? $this->input['cert_contact_city'] : null,
            'error' => (!empty($this->fieldErorrs['cert_contact_city'])),
            'require' => true
        ));

        $this->form->addField('Text',
            array(
            'name' => 'contact_email',
            'value' => isset($this->input['cert_contact_email']) ? $this->input['cert_contact_email'] : null,
            'error' => (!empty($this->fieldErorrs['cert_contact_email'])),
            'require' => true
        ));


        $this->form->addField('Text',
            array(
            'name' => 'contact_phone',
            'value' => isset($this->input['cert_contact_phone']) ? $this->input['cert_contact_phone'] : null,
            'error' => (!empty($this->fieldErorrs['cert_contact_phone'])),
            'require' => true
        ));

        $this->form->addField('Text',
            array(
            'name' => 'contact_postalcode',
            'value' => isset($this->input['cert_contact_postalcode']) ? $this->input['cert_contact_postalcode'] : null,
            'error' => (!empty($this->fieldErorrs['cert_contact_postalcode'])),
            'require' => true
        ));

        $this->form->addField('Text',
            array(
            'name' => 'contactorg_name',
            'value' => isset($this->input['cert_contactorg_name']) ? $this->input['cert_contactorg_name'] : null,
            'error' => (!empty($this->fieldErorrs['cert_contactorg_name'])),
            'require' => false
        ));

        $this->form->addField('Text',
            array(
            'name' => 'contact_taxIdentificationNumber',
            'value' => isset($this->input['cert_contact_taxIdentificationNumber']) ? $this->input['cert_contact_taxIdentificationNumber'] : null,
            'error' => (!empty($this->fieldErorrs['cert_contact_taxIdentificationNumber'])),
            'require' => false
        ));

        $this->form->addField('Text',
            array(
            'name' => 'org_verifiphonenumber',
            'value' => isset($this->input['cert_org_verifiphonenumber']) ? $this->input['cert_org_verifiphonenumber'] : null,
            'error' => (!empty($this->fieldErorrs['cert_org_verifiphonenumber'])),
            'require' => false
        ));

        //Required fields Not Exists for This product Type
        if ($productFields == null) {

            $this->form->addField('Text',
                array(
                'name' => 'org_name',
                'value' => isset($this->input['cert_org_name']) ? $this->input['cert_org_name'] : null,
                'error' => (!empty($this->fieldErorrs['cert_org_name'])),
                'require' => true
            ));

            $this->form->addField('Text',
                array(
                'name' => 'org_address_city',
                'value' => isset($this->input['cert_org_address_city']) ? $this->input['cert_org_address_city'] : null,
                'error' => (!empty($this->fieldErorrs['cert_org_address_city'])),
                'require' => true
            ));

            $this->form->addField('Select',
                array(
                'name' => 'org_address_country',
                'value' => isset($this->input['cert_org_address_country']) ? $this->input['cert_org_address_country'] : null,
                'options' => CertumSSLCertificate::getCountries(),
                'require' => true
            ));

            $this->form->addField('Text',
                array(
                'name' => 'org_address_region',
                'value' => isset($this->input['cert_org_address_region']) ? $this->input['cert_org_address_region'] : null,
                'error' => (!empty($this->fieldErorrs['cert_org_address_region'])),
                'require' => true
            ));

            $this->form->addField('Text',
                array(
                'name' => 'org_address_email',
                'value' => isset($this->input['cert_org_address_email']) ? $this->input['cert_org_address_email'] : null,
                'error' => (!empty($this->fieldErorrs['cert_org_address_email'])),
                'require' => true
            ));

            $this->form->addField('Text',
                array(
                'name' => 'org_taxIdentificationNumber',
                'value' => isset($this->input['cert_org_taxIdentificationNumber']) ? $this->input['cert_org_taxIdentificationNumber'] : null,
                'error' => (!empty($this->fieldErorrs['cert_org_taxIdentificationNumber'])),
                'require' => true
            ));
        }

        $this->form->addField('Submit', array(
            'name' => 'action',
            'value' => 'submitCertificate',
            'cancel' => true
        ));

        return $this->form->getHTML();
    }
}