<?php if (!empty($errors)): ?>
    <div class="alert alert-danger">
        <?php foreach ($errors as $errorController): ?>
            <?php foreach ($errorController as $error): ?>
                <?php
                if (empty($error)) {
                    echo MGLang::T('errorMessages', 'general');
                } elseif (is_array($error)) {
                    echo $error[0];
                } else {
                    echo $error;
                }
                ?>
            <?php endforeach; ?>
        <?php endforeach; ?>
    </div>
<?php endif; ?>
<?php if (!empty($success)): ?>
    <div class="alert alert-success">
        <?php echo $success; ?>
    </div>
<?php endif; ?>
<legend><?php echo MGLang::T('certDetails', 'currentlyInstalled'); ?></legend>
<table class="table table-hover">
    <thead>
        <tr>
            <th><?php echo MGLang::T('thead', 'certName'); ?></th>
            <th><?php echo MGLang::T('thead', 'certSerialNumber'); ?></th>
            <th><?php echo MGLang::T('thead', 'domain'); ?></th>
            <th><?php echo MGLang::T('thead', 'activated'); ?></th>
            <th><?php echo MGLang::T('thead', 'validFrom'); ?></th>
            <th><?php echo MGLang::T('thead', 'validUntil'); ?></th>
            <th><?php echo MGLang::T('thead', 'cert_status'); ?></th>
            <th><?php echo MGLang::T('thead', 'install_status'); ?></th>
            <th><?php echo MGLang::T('thead', 'actions'); ?></th>
        </tr>
    </thead>
    <tbody>

        <?php if (!empty($certs)): ?>
            <?php
            //echo '<pre>';
            //var_dump($certs);die;
            ?>
            <?php foreach ($certs as $cert): ?>

                <tr>
                    <td><?php echo $cert['certName']; ?></td>
                    <td><?php echo (isset($cert['certSerialNumber'])) ? $cert['certSerialNumber'] : 'None'; ?></td>
                    <td><?php 
                        if(strpos($cert['certName'],'Wildcard') !== false){
                            echo '*.'.$cert['domainid'];
                        }else{
                            echo $cert['domainid'];
                            
                        } ?></td>
                    <td><?php echo $cert['activateddate']; ?></td>
                    <td><?php echo (isset($cert['startDate'])) ? date("Y-m-d H:i:s", strtotime($cert['startDate'])) : 'None'; ?></td>
                    <td><?php echo (isset($cert['endDate'])) ? date("Y-m-d H:i:s", strtotime($cert['endDate'])) : 'None'; ?></td>
                    <td id="op_cert_status_<?php echo $cert['orderid']; ?>"><?php echo $cert['cert_status']; ?></td>
                    <td id="op_status_<?php echo $cert['orderid']; ?>"><?php echo $cert['status']; ?></td>
                    <td style="width:17%;">
                        <button id="op_details_button_<?php echo $cert['orderid']; ?>" class="btn btn-info btn-xs op_details_button" data-toggle="modal" data-target="#certDetails" data-relid="<?php echo $cert['relid']; ?>" data-orderid="<?php echo $cert['orderid']; ?>" data-action="certInfo" data-domain="<?php echo $cert['domainid']; ?>" data-token="<?php echo $cert['token']; ?>"><?php echo MGLang::T('actions',
            'details'); ?></button>
        <?php if (isset($cert['certSerialNumber']) && !$cert['reissued'] && $cert['cert_status'] == 'VALID'): ?>
                            <form class="form-horizontal" action="" method="post">
                                <input type="hidden" name="orderid" value="<?php echo $cert['orderid']; ?>">
                                <input type="hidden" name="serialNumber" value="<?php echo $cert['certSerialNumber']; ?>">
                                <input type="hidden" name="domain" value="<?php echo $cert['domainid']; ?>">
                                <input type="hidden" name="token" value="<?php echo $cert['token']; ?>">
                                <button id="op_reissue_button_<?php echo $cert['orderid']; ?>" type="submit" name="action" class="btn btn-info btn-xs op_reissue_button" data-relid="<?php echo $cert['relid']; ?>" data-orderid="<?php echo $cert['orderid']; ?>" data-certserialnumber="<?php echo $cert['certSerialNumber']; ?>" data-action="certReissue" data-domain="<?php echo $cert['domainid']; ?>" data-token="<?php echo $cert['token']; ?>" value="certReissue"><?php echo MGLang::T('actions',
                'reissue'); ?></button>
                            </form>
                        <?php endif; ?>
                        <?php if (isset($cert['certSerialNumber']) && $cert['cert_status'] != 'REVOKED' && $cert['cert_status'] != 'REVOKING' && $cert['cert_status']
                            != 'REJECTED'): ?>
                            <button id="op_revoke_button_<?php echo $cert['orderid']; ?>" type="button" class="btn btn-info btn-xs op_revoke_button" data-relid="<?php echo $cert['relid']; ?>" data-orderid="<?php echo $cert['orderid']; ?>" data-certserialnumber="<?php echo $cert['certSerialNumber']; ?>" data-action="certRevoke" data-domain="<?php echo $cert['domainid']; ?>" data-token="<?php echo $cert['token']; ?>"><?php echo MGLang::T('actions',
                    'revoke'); ?></button>
        <?php endif; ?>
                <?php if ($cert['cert_status'] == 'REVOKED' || $cert['cert_status'] == 'AWAITING'): ?>
                            <button id="op_cancel_button_<?php echo $cert['orderid']; ?>" type="button" class="btn btn-info btn-xs op_cancel_button" data-relid="<?php echo $cert['relid']; ?>" data-action="certCancel" data-orderid="<?php echo $cert['orderid']; ?>" data-domain="<?php echo $cert['domainid']; ?>" data-token="<?php echo $cert['token']; ?>"><?php echo MGLang::T('actions',
                'cancel'); ?></button>
        <?php endif; ?>
                    </td>
                </tr>
            <?php endforeach; ?>
<?php else: ?>
            <tr>
                <td colspan="5" align="center"><?php echo MGLang::T('certs', 'noinstalled'); ?></td>
            </tr>
<?php endif; ?>
    </tbody>
</table>
<?php if (!empty($certs)): ?>
    <div class="modal fade" id="certDetails" data-dismiss="modal"  data-backdrop="false" data-target-on-load="getInfo" tabindex="-1" role="dialog" aria-labelledby="certDetailsLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true" >&times;</span></button>
                    <h4 class="modal-title" id="certDetailsLabel"><?php echo MGLang::T('popup', 'certDetails', 'title'); ?></h4>
                </div>
                <div class="modal-loader"></div>
                <div class="modal-body">
                    <div class="op_info_content" id="orderdefault">
                        <div class="op_info_head"><?php echo MGLang::T('popup', 'orderInfo', 'title'); ?></div>
                        <div class="op_row">
                            <?php echo MGLang::T('popup', 'vouchercode'); ?> <span id="op_voucherCode"></span>
                        </div>
                        <div class="op_row">
                            <?php echo MGLang::T('popup', 'orderid'); ?> <span id="op_orderID"></span>
                        </div>
                        <div class="op_row">
    <?php echo MGLang::T('popup', 'domainname'); ?> <span id="op_domainName"></span>
                        </div>
                        <div class="op_row">
                            <?php echo MGLang::T('popup', 'revokeDate'); ?> <span id="op_revokedDate">N/A</span>
                        </div>
                    </div>
                    <div class="op_info_content" id="organizationInfo">
                        <div class="op_info_head"><?php echo MGLang::T('popup', 'organisationInfo', 'title'); ?></div>
                        <div class="op_row op_single_param">
    <?php echo MGLang::T('popup', 'orgname'); ?>  <span id="op_organizationName"></span>
                        </div>
                        <div class="op_row op_single_param">
                            <?php echo MGLang::T('popup', 'orgtaxid'); ?> <span id="op_taxIdentificationNumber"></span>
                        </div>
                    </div>
                    <div class="op_info_content" id="requestorInfo">
                        <div class="op_info_head"><?php echo MGLang::T('popup', 'contactInfo', 'title'); ?></div>
                        <div class="op_row op_single_param">
                            <?php echo MGLang::T('popup', 'contactfirstname'); ?> <span id="op_firstName"></span>
                        </div>
                        <div class="op_row op_single_param">
                            <?php echo MGLang::T('popup', 'contactlastname'); ?> <span id="op_lastName"></span>
                        </div>
                        <div class="op_row op_single_param">
                            <?php echo MGLang::T('popup', 'contactcountry'); ?> <span id="op_country"></span>
                        </div>
                        <div class="op_row op_single_param">
                            <?php echo MGLang::T('popup', 'contactcity'); ?> <span id="op_city"></span>
                        </div>
                        <div class="op_row op_single_param">
                            <?php echo MGLang::T('popup', 'contactaddress'); ?> <span id="op_addressLine1"></span>
                        </div>
                        <div class="op_row op_single_param">
                            <?php echo MGLang::T('popup', 'contactphone'); ?> <span id="op_phone"></span>
                        </div>
                        <div class="op_row op_single_param">
    <?php echo MGLang::T('popup', 'contactemail'); ?> <span id="op_email"></span>
                        </div>
                        <div class="op_row op_single_param">
    <?php echo MGLang::T('popup', 'contactpostalcode'); ?> <span id="op_postalCode"></span>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal"><?php echo MGLang::T('certDetails',
        'cancel'); ?></button>
                </div>
            </div>
        </div>
    </div>
    <div class="op_loader">
        <div class="windows8">
            <div class="modal-loader"></div>
        </div>
    </div>
    <script type="text/javascript">

        $(document).ready(function () {
            $('body').css('position', 'relative');
            $('.btn').click(function () {
                var button = $(this);
                var certAction = $(this).data('action');
                if (typeof certAction !== "undefined") {
                    var domain = $(this).data('domain');
                    var voucher = $(this).data('token');
                    var orderid = $(this).data('orderid');
                    var relid = $(this).data('relid');
                    var certserialnumber = $(this).data('certserialnumber');
                    if (certAction != 'certInfo' && certAction != 'certReissue') {

                        if (certAction != 'certCancel' && certAction != 'certRevoke') {
                            var r = true;
                        } else if (certAction == 'certRevoke') {
                            var txt;
                            var r = confirm("Are you sure you want to Revoke this certificate?");
                        } else {
                            var txt;
                            var r = confirm("Are you sure you want to cancel this certificate?");
                        }

                        if (r == true) {
                            $(".op_loader").show();
                            $.ajax({
                                type: "POST",
                                url: window.location.href,
                                data: {action: certAction, orderID: orderid, serialNumber: certserialnumber,relid:relid},
                                success: function (result) {
                                    $(".op_loader").hide();
                                    $("#MGErrors").remove();
                                    var startString = "<<JSON RESPONSE START>>";
                                    var stopString = "<<JSON RESPONSE END>>";
                                    var start = result.lastIndexOf(startString);
                                    var stop = result.indexOf(stopString);
                                    var jsonResponse = result.substr(start + startString.length, stop);
                                    var responseObject = $.parseJSON(jsonResponse.replace('<<JSON RESPONSE END>>', ''));
                                    //$('.alert.alert-danger').text("");
                                    $('.alert.alert-success').show("");
                                    $('.alert.alert-danger').remove();
                                    if (responseObject.status == "error") {
                                        var errors = jQuery.parseJSON(responseObject.errors);
                                        var errorsResponse = "";
                                        $.each(errors, function (key, errorParams) {
                                            if ($.isArray(errorParams)) {
                                                $.each(errorParams, function (keey, Paramobj) {
                                                    errorsResponse += '<div>' + Paramobj.text + '</div><br>';
                                                });
                                            } else {
                                                errorsResponse += '<div>' + errorParams + '</div>';
                                            }
                                        });
                                        var errorContent = '<div class="row" id="MGErrors">'
                                                + '<div class="col-lg-12">'
                                                + '<div class="alertContainer">'
                                                + '<div class="alertPrototype" style="">'
                                                + '<div class="alert alert-danger">' + errorsResponse + '</div>'
                                                + '</div>\n'
                                                + '</div>'
                                                + '</div>'
                                                + '</div>';
                                        $("#MGContent").prepend(errorContent);
                                    } else {
                                        $('.alertContainer').parent().remove();
                                        var successContent = '<div class="row" id="MGErrors">'
                                                + '<div class="col-lg-12">'
                                                + '<div class="alertContainer">'
                                                + '<div class="alertPrototype" style="">'
                                                + '<div class="alert alert-success">' + responseObject.msg + '</div>'
                                                + '</div>\n'
                                                + '</div>'
                                                + '</div>'
                                                + '</div>';
                                        $("#MGContent").prepend(successContent);
                                        if (responseObject.action == 'REVOKING') {
                                            $('#op_cert_status_' + orderid).html('REVOKING');
                                            button.remove();
                                            $('#op_reissue_button_' + orderid).parent().remove();
                                        } else if (responseObject.action == 'CANCEL') {
                                            $('#op_cert_status_' + orderid).html('REJECTED');
                                            button.remove();
                                        }
                                    }

                                }
                            });
                        }
                    }
                }

                if (certAction == 'certInfo') {
                    var domain = $(this).data('domain');
                    var voucher = $(this).data('token');
                    var orderid = $(this).data('orderid');
                    var relid = $(this).data('relid');

                    var action = 'getInfo';
                    $("#cpanel_body").css("position", "static");
                    $('.modal-loader').show();
                    $("#orderdefault").hide();
                    $("#organizationInfo").hide();
                    $("#requestorInfo").hide();

                    ajaxParser.request(
                            action,
                            {domainName: domain, voucherCode: voucher, orderID: orderid, relid:relid},
                            function (result) {
                                var orderDetails = jQuery.parseJSON(result);
                                $.each(orderDetails, function (infoHead, infoParams) {
                                    $("#" + infoHead).show();
                                    $("#op_revokedDate").text("N/A");
                                    $.each(infoParams, function (inputName, inputValue) {
                                        console.log(inputName);
                                        $('#op_' + inputName).text(inputValue);
                                        $('#op_' + inputName).parent().show();
                                    });
                                });

                                $('.modal-loader').hide();
                            }
                    );
                }
            });
        });
    </script>
<?php endif; ?>
<legend><?php echo MGLang::T('certDetails', 'addNew'); ?></legend>
<?php echo $addForm; ?>