<?php
/**
 * Partner API Library
 * 
 * @copyright Copyright (c) 2013-2014 Unizeto Technologies SA
 * @license license.txt
 */

//require_once 'type.php';
//require_once 'typeDocument.php';

/*
<xs:complexType name="documents">
    <xs:sequence>
        <xs:element maxOccurs="unbounded" name="document" type="tns:document"/>    
    </xs:sequence>
</xs:complexType>
*/

/**
 * This class represents the "documents" WSDL type.
 * 
 * It is based on the PartnerAPIType class and derives some properties and methods from that class.
 * 
 * @method PartnerAPITypeDocuments setDocument(PartnerAPITypeDocument $value The document to be set) Sets the "document" element. This method removes all previously added "document" elements and creates a new set of "document" elements.
 * @method PartnerAPITypeDocuments addDocument(PartnerAPITypeDocument $value The document to be added) Adds a new "document" element to the set of documents.
 * @method PartnerAPITypeDocument|PartnerAPITypeDocument[] getDocument() Gets the "document" element. If there is only one element, it will be returned, otherwise an array of PartnerAPITypeDocument objects will be returned.
 * @property PartnerAPITypeDocument|PartnerAPITypeDocument[] $document Gets the "document" element. If there is only one element, it will be returned, otherwise an array of PartnerAPITypeDocument objects will be returned.
 * 
 * @package types
 * @since 1.4.1
 */
class PartnerAPITypeDocuments extends PartnerAPIType {
    
    protected function initData() {
        return array(
            'document' => array('min' => 1, 'max' => NULL, 'value' => new PartnerAPITypeDocument(), 'type' => 'PartnerAPITypeDocument', 'nillable' => FALSE)
        );
    }

}
