<?php

/* * ********************************************************************
 * Customization Services by ModulesGarden.com
 * Copyright (c) ModulesGarden, INBS Group Brand, All Rights Reserved 
 * (2016-01)
 * 
 *
 *  CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Grzegorz Draganik <grzegorz@modulesgarden.com>
 * @author Piotr Kozdęba <piotr.ko@modulesgarden.com>
 */

/**
 * DirectAdmin API - Domain Management
 */
class DirectadminApiDomainDriver extends DirectadminApiDriver
{

    public $domain;
    public $domainUsername;
    public $domainPointsTo;

    /**
     * Sets new domain object (inside Api)
     */
    public function __construct($domain, $username, $pointsto = null, $host = null, $login = null, $pass = null, $secure = true, $port = 2222)
    {
        parent::__construct($host, $login, $pass, $secure, $port);
        $this->domain = $domain;
        $this->domainUsername = $username;
        $this->domainPointsTo = $pointsto;
    }
    
    /**
     * Checks first MX record
     * @return bool
     */
    public function isRemote()
    {
        $api = new DirectadminApiDomainsDriver($this->host, $this->login, $this->pass, $this->secure, $this->port);
        $records = $api->getDomainsMxRecords($this->domain);
        return isset($records[0]['isRemote']) && $records[0]['isRemote'];
    }
	
}


        
        
        
	
	
        
        