<?php

class WHMConfigurationController extends AbstractControler
{

    function __construct($params, $options)
    {
        parent::__construct($params, $options);
    }

    public function MainHTMLAction($input, $data = array())
    {
        $fieldErorrs      = isset($data['fieldErrors']) ? $data['fieldErrors'] : array();
        $predefinedConfig = parse_ini_file(CERTUMSSL_ROOT.DS.'etc'.DS.'PredefinedConfiguration.ini');

        $data['isForm'] = true;

        $form = new FormCreator('sys', $this, array(
            'url' => $this->getCurrentAction()
        ));

        $customParams['doubleButtons'][0] = array('name' => 'submitLoadConfFile', 'value' => 'loadConfFile');
        $customParams['doubleButtons'][1] = array('name' => 'submitSaveConfFile', 'value' => 'saveConfFile');
        $form->addField('Submit',
            array(
            'name' => 'action',
            'value' => 'double',
            'frendlyName' => 'double',
            'skipLabel' => true,
            'customParams' => $customParams
        ));

        /*
         * API SECTION
         */
        $form->addField('Legend', array(
            'name' => 'admin_api_section'
        ));

        $form->addField('Hidden', array(
            'name' => 'testConnectionId',
            'value' => 'asdasd',
        ));

        //echo '<pre>';
        //var_dump($form);die;
        // TO DO get API Accounts Params sorted By relid
        $configuration = new CertumSSLConfiguration();

        if (count($configuration->getAPIAccountsParams()) <= 0) {

            $relid = 1;
            $form->addField('Text',
                array(
                'name' => 'api_login_'.$relid,
                'value' => isset($input['sys_api_login_'.$relid]) ? $input['sys_api_login_'.$relid] : $predefinedConfig['api_login'],
                'error' => (!empty($fieldErorrs['sys_api_login_'.$relid]))
            ));

            $form->addField('Text',
                array(
                'name' => 'api_password_'.$relid,
                'value' => isset($input['sys_api_password_'.$relid]) ? $input['sys_api_password_'.$relid] : $predefinedConfig['api_password'],
                'error' => (!empty($fieldErorrs['sys_api_password_'.$relid]))
            ));

            $form->addField('Text',
                array(
                'name' => 'api_wsdl_url_'.$relid,
                'value' => isset($input['sys_api_wsdl_url_']) ? $input['sys_api_wsdl_url_'.$relid] : $predefinedConfig['api_wsdl_url'],
                'error' => (!empty($fieldErorrs['sys_api_wsdl_url_'.$relid]))
            ));

            $SSLProducts = new SSLProducts();

            $form->addField('MultiSelect', array(
                'name' => 'api_wsdl_products_'.$relid,
                'options' => $SSLProducts->names,
            ));

            $form->addField('Text',
                array(
                'name' => 'api_wsdl_lang_'.$relid,
                'value' => isset($input['sys_api_wsdl_lang_'.$relid]) ? $input['sys_api_wsdl_lang_'.$relid] : $predefinedConfig['api_wsdl_lang'],
                'error' => (!empty($fieldErorrs['sys_api_wsdl_lang_'.$relid]))
            ));

            $customParams['doubleButtons'][0] = array('name' => 'testConnect', 'value' => 'testConnect');
            $customParams['doubleButtons'][1] = array('name' => 'addNewAccount', 'type' => 'button', 'value' => 'addNewAccount', 'data-lastrelid' => $relid);
            $form->addField('Submit',
                array(
                'name' => 'action',
                'value' => 'double',
                'frendlyName' => 'double',
                'skipLabel' => false,
                'customParams' => $customParams
            ));
        } else {
            $i = 0;
            foreach ($configuration->getAPIAccountsParams() as $relid => $accountParams) {
                $i++;
                $form->addField('Text',
                    array(
                    'name' => 'api_login_'.$relid,
                    'value' => isset($input['sys_api_login_'.$relid]) ? $input['sys_api_login_'.$relid] : (isset($accountParams['api_login']) ? $accountParams['api_login'] : $predefinedConfig['api_login']),
                    'error' => (!empty($fieldErorrs['sys_api_login_'.$relid]))
                ));

                $form->addField('Text',
                    array(
                    'name' => 'api_password_'.$relid,
                    'value' => isset($input['sys_api_password_'.$relid]) ? $input['sys_api_password_'.$relid] : (isset($accountParams['api_password']) ? $accountParams['api_password']
                                : $predefinedConfig['api_password']),
                    'error' => (!empty($fieldErorrs['sys_api_password_'.$relid]))
                ));

                $form->addField('Text',
                    array(
                    'name' => 'api_wsdl_url_'.$relid,
                    'value' => isset($input['sys_api_wsdl_url_']) ? $input['sys_api_wsdl_url_'.$relid] : (isset($accountParams['api_wsdl_url']) ? $accountParams['api_wsdl_url'] : $predefinedConfig['api_wsdl_url']),
                    'error' => (!empty($fieldErorrs['sys_api_wsdl_url_'.$relid]))
                ));

                $SSLProducts = new SSLProducts();

                $form->addField('MultiSelect',
                    array(
                    'name' => 'api_wsdl_products_'.$relid,
                    'options' => $SSLProducts->names,
                    'customParams' => array('selected' => $configuration->getProductsByRelId($relid))
                ));

                $form->addField('Text',
                    array(
                    'name' => 'api_wsdl_lang_'.$relid,
                    'value' => isset($input['sys_api_wsdl_lang_'.$relid]) ? $input['sys_api_wsdl_lang_'.$relid] : (isset($accountParams['api_wsdl_lang']) ? $accountParams['api_wsdl_lang']
                                : $predefinedConfig['api_wsdl_lang']),
                    'error' => (!empty($fieldErorrs['sys_api_wsdl_lang_'.$relid]))
                ));

                if (count($configuration->getAPIAccountsParams()) != $i) {
                    $customParams['doubleButtons'][0] = array('name' => 'testConnect', 'value' => 'testConnect', 'isTestConnection' => true, 'related' => $i);
                    unset($customParams['doubleButtons'][1]);
                    $form->addField('Submit',
                        array(
                        'name' => 'action',
                        'value' => 'double',
                        'frendlyName' => 'double',
                        'skipLabel' => false,
                        'customParams' => $customParams
                    ));
                }

                if (count($configuration->getAPIAccountsParams()) == $i) {
                    unset($customParams['doubleButtons'][0]);
                    unset($customParams['doubleButtons'][1]);
                    $customParams['doubleButtons'][0] = array('name' => 'testConnect', 'value' => 'testConnect', 'isTestConnection' => true, 'related' => $i);
                    $customParams['doubleButtons'][1] = array('name' => 'addNewAccount', 'type' => 'button', 'value' => 'addNewAccount', 'data-lastrelid' => $i);
                    $form->addField('Submit',
                        array(
                        'name' => 'action',
                        'value' => 'double',
                        'frendlyName' => 'double',
                        'skipLabel' => false,
                        'customParams' => $customParams
                    ));
                }
            }
        }

        /*
         * ADMIN NOTIFICATIONS
         */
        $form->addField('Legend', array(
            'name' => 'admin_notification_section'
        ));

        $form->addField('Text',
            array(
            'name' => 'email',
            'value' => isset($input['sys_email']) ? $input['sys_email'] : (isset(CertumSSLDriver::config()->email) ? CertumSSLDriver::config()->email : $predefinedConfig['email']),
            'error' => (!empty($fieldErorrs['sys_email']))
        ));

        $form->addField('Text',
            array(
            'name' => 'sender',
            'value' => isset($input['sys_sender']) ? $input['sys_sender'] : (isset(CertumSSLDriver::config()->sender) ? CertumSSLDriver::config()->sender : $predefinedConfig['sender']),
            'error' => (!empty($fieldErorrs['sys_sender']))
        ));


        /*
         * USER NOTIFICATIONS
         */
        $form->addField('Legend', array(
            'name' => 'user_notification_section'
        ));

        $form->addField('Text',
            array(
            'name' => 'success_email_subject',
            'value' => isset($input['sys_success_email_subject']) ? $input['sys_success_email_subject'] : (isset(CertumSSLDriver::config()->success_email_subject) ? CertumSSLDriver::config()->success_email_subject
                        : $predefinedConfig['success_email_subject'])
        ));

        $form->addField('TextArea',
            array(
            'rows' => 10,
            'cols' => 84,
            'name' => 'success_email_message',
            'value' => isset($input['sys_success_email_message']) ? $input['sys_success_email_message'] : (isset(CertumSSLDriver::config()->success_email_message) ? CertumSSLDriver::config()->success_email_message
                        : $predefinedConfig['success_email_message']),
            'enableDescription' => true
        ));

        //Billing Configuration
        $form->addField('Legend', array(
            'name' => 'billing_config_subject'
        ));

        $form->addField('Text',
            array(
            'name' => 'billing_url',
            'value' => isset($input['sys_billing_url']) ? $input['sys_billing_url'] : (isset(CertumSSLDriver::config()->billing_url) ? CertumSSLDriver::config()->billing_url : $predefinedConfig['billing_url']),
            'error' => (!empty($fieldErorrs['sys_billing_url'])),
            'enableDescription' => true
        ));

        //API Logs Configuration
        $form->addField('Legend', array(
            'name' => 'logs_limit_subject'
        ));

        $form->addField('Text',
            array(
            'name' => 'logs_limit',
            'value' => isset($input['sys_logs_limit']) ? $input['sys_logs_limit'] : (isset(CertumSSLDriver::config()->logs_limit) ? CertumSSLDriver::config()->logs_limit : $predefinedConfig['logs_limit']),
            'error' => (!empty($fieldErorrs['sys_logs_limit'])),
            'enableDescription' => true
        ));

        $form->addField('Submit',
            array(
            'name' => 'action',
            'value' => 'save',
            'frendlyName' => 'submitSave',
            'skipLabel' => false
        ));

        $data['formAPI'] = $form->getHTML();

        return array(
            'template' => 'Configuration',
            'vars' => $data
        );
    }

    public function saveHTMLAction($input, $data = array())
    {

        //echo '<pre>';

        $configuration = new CertumSSLConfiguration();

        //$configuration->setAPIAccountsParams($name, $value, $relid);

        foreach ($input as $inpuName => $inpuVal) {

            if (strpos($inpuName, "sys_api_") !== false) {
                $last  = strrpos($inpuName, "_");
                $relid = substr($inpuName, (int) $last + 1 - strlen($inpuName));
                $name  = substr($inpuName, 4, $last - 4);

                if (strpos($inpuName, "api_wsdl_products") !== false) {
                    $inpuVal = json_encode($inpuVal);
                }
                $configuration->setAPIAccountsParams($name, $inpuVal, $relid);
            }
        }

        CertumSSLDriver::config()->email  = $input['sys_email'];
        CertumSSLDriver::config()->sender = $input['sys_sender'];

        CertumSSLDriver::config()->success_email_subject = $input['sys_success_email_subject'];
        CertumSSLDriver::config()->success_email_message = $input['sys_success_email_message'];

        CertumSSLDriver::config()->billing_url = $input['sys_billing_url'];

        CertumSSLDriver::config()->logs_limit = $input['sys_logs_limit'];

        $data['success'] = MGLang::T('saveSuccess');

        return $this->MainHTMLAction($input, $data);
    }

    public function testConnectHTMLAction($input, $data = array())
    {

        if (isset($input['sys_testConnectionId'])) {
            $connectionParams = array(
                'api_login' => $input['sys_api_login_'.$input['sys_testConnectionId']],
                'api_password' => $input['sys_api_password_'.$input['sys_testConnectionId']],
                'api_url' => $input['sys_api_wsdl_url_'.$input['sys_testConnectionId']],
                'api_wsdl_lang' => $input['sys_api_wsdl_lang_'.$input['sys_testConnectionId']],
            );

            CertumSSLDriver::remoteAPI()->setConnectionParams($connectionParams);
            $op = CertumSSLDriver::remoteAPI()->operationGetProductList();

            if ($op->call()) {
                $data['success'] = MGLang::T('connectSuccess');
            } else {
                $data['error'] = MGLang::T('connectError');
            }

            $configuration = new CertumSSLConfiguration();
            $configuration->setAPIAccountsParams('api_login', $input['sys_api_login_'.$input['sys_testConnectionId']], $input['sys_testConnectionId']);
            $configuration->setAPIAccountsParams('api_password', $input['sys_api_password_'.$input['sys_testConnectionId']], $input['sys_testConnectionId']);
            $configuration->setAPIAccountsParams('api_wsdl_url', $input['sys_api_wsdl_url_'.$input['sys_testConnectionId']], $input['sys_testConnectionId']);
            $configuration->setAPIAccountsParams('api_wsdl_lang', $input['sys_api_wsdl_lang_'.$input['sys_testConnectionId']], $input['sys_testConnectionId']);
            $configuration->setAPIAccountsParams('api_wsdl_products', json_encode($input['sys_api_wsdl_products_'.$input['sys_testConnectionId']]), $input['sys_testConnectionId']);
        }
        return $this->MainHTMLAction($input, $data);
    }

    public function loadConfFileHTMLAction()
    {
        $predefinedConfig = parse_ini_file(CERTUMSSL_ROOT.DS.'etc'.DS.'PredefinedConfiguration.ini');
        $configuration    = new CertumSSLConfiguration();
        foreach ($predefinedConfig as $configName => $configValues) {
            if (strpos($configName, "api_") !== false && is_array($configValues)) {

                foreach ($configValues as $relid => $value) {
                    if (strpos($configName, "api_wsdl_products") !== false) {
                        $productsArray = explode(",", $value);
                        $value         = json_encode($productsArray);
                    }

                    $configuration->setAPIAccountsParams($configName, $value, $relid);
                }
            } else {
                $configuration->setAPIAccountsParams($configName, $configValues, 0);
            }
        }

        $data['success'] = MGLang::T('loadConfigMessage');

        return $this->MainHTMLAction(null, $data);
    }

    public function saveConfFileHTMLAction($input, $data = array())
    {
        $res = array();
        foreach ($input as $inpuName => $inpuVal) {

            if (strpos($inpuName, "sys_api_") !== false) {
                $last  = strrpos($inpuName, "_");
                $relid = substr($inpuName, (int) $last + 1 - strlen($inpuName));

                $name = substr($inpuName, 4, $last - 4);

                if (strpos($inpuName, "api_wsdl_products") !== false) {
                    $inpuVal = implode(",", $inpuVal);
                }

                $res[] = $name."[".$relid."] = ".$inpuVal;
            } else {
                if (strpos($inpuName, 'sys_') !== false && strpos($inpuName, 'sys_testConnectionId') === false) {
                    $inpuName = str_replace("sys_", "", $inpuName);
                    if (is_array($inpuVal)) {
                        $res[] = "[$inpuName]";
                        foreach ($inpuVal as $skey => $sval)
                            $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
                    } else {
                        $res[] = "$inpuName = ".(is_numeric($inpuVal) ? $inpuVal : '"'.$inpuVal.'"');
                    }
                }
            }
        }
        $dataToSave = implode("\r\n", $res);

        $configFile = fopen(CERTUMSSL_ROOT.DS.'etc'.DS.'PredefinedConfiguration.ini', 'w');
        fwrite($configFile, $dataToSave);
        fclose($configFile);

        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename="'.basename(CERTUMSSL_ROOT.DS.'etc'.DS.'PredefinedConfiguration.ini').'"');
        header('Expires: 0');
        header('Cache-Control: must-revalidate');
        header('Pragma: public');
        header('Content-Length: '.filesize(CERTUMSSL_ROOT.DS.'etc'.DS.'PredefinedConfiguration.ini'));
        readfile(CERTUMSSL_ROOT.DS.'etc'.DS.'PredefinedConfiguration.ini');
        exit;
    }
}