<?php

class WHMMainCronController extends AbstractControler
{

    public function MainHTMLAction()
    {
        return $this->recentlyCronAction();
    }

    function recentlyCronAction()
    {

        echo "---Cron Start---\n\n";
        $logContent = "---Cron Start---\n\n";

        $parentsCertOrders = new MGCertOrders(array('_tableName' => 'certumssl_orders'));
        $parentsOrder      = $parentsCertOrders->getAllOrders();

        echo "---Start creating required files---\n\n";
        $logContent .= "---Start creating required files---\n\n";

        if ($parentsOrder) {
            foreach ($parentsOrder as $parentOrder) {

                echo "User:".$parentOrder['user_id']."\n";
                $logContent .= "User:".$parentOrder['user_id']."\n";
                echo "Order ID:".$parentOrder['order_id']."\n";
                $logContent .= "Order ID:".$parentOrder['order_id']."\n";

                $domain         = "";
                $domainRootName = "";

                $notification  = new MGNotification();
                $domainsParams = CertumSSLDriver::localAPI()->getUserDomains($parentOrder['user_id']);

                echo "---Check user domain when he ordering cert---\n";
                $logContent .= "---Check user domain when he ordering cert---\n";
                echo "Domain Name when ordered: ".$parentOrder['domain_id']."\n";
                $logContent .= "Domain Name when ordered: ".$parentOrder['domain_id']."\n";
                echo "User Domains:";
                $logContent .= "User Domains:";

                //Sprawdzamy czy urzytkownik posiada jeszcze domene ktora mial przy zamowiowieniu
                foreach ($domainsParams as $domainParam) {

                    echo $domainParam['domain'].",";
                    $logContent .= $domainParam['domain'].",";

                    if ($domainParam['domain'] == $parentOrder['domain_id']) {
                        $domain = $parentOrder['domain_id'];
                    }
                }

                echo "\n";
                $logContent .= "\n";

                if ($domain != "") {

                    echo "Domain Found\n";
                    $logContent .= "Domain Found\n";
                    echo "---End check user domain when he ordering cert---\n";
                    $logContent .= "---End check user domain when he ordering cert---\n";

                    $taskParams         = array();
                    //Można wykozystać jako logi
                    $task               = new MGCronTask(array('_tableName' => 'certumssl_cron_tasks'));
                    $task->orderId      = $parentOrder['order_id'];
                    $task->userId       = $parentOrder['user_id'];
                    $task->domainId     = $parentOrder['domain_id'];
                    $task->activateDate = '0000-00-00 00:00:00';
                    $taskParams         = $task->getTaskByOrderId($parentOrder['order_id']);
                    //Tworzy Cron Taska jesli jeszcze nie istnieje
                    if (empty($taskParams)) {
                        $task->create();
                    }

                    $task->updateLastTry();

                    $clientName   = $parentOrder['user_id'];
                    $userAccounts = CertumSSLDriver::localAPI()->getAccounts();
                    foreach ($userAccounts as $userAccount) {
                        if ($userAccount['name'] == $clientName) {
                            $userEmail = $userAccount['email'];
                        }
                    }

                    $adminEmailNotifySend = array();
                    $adminEmailNotifySend = $task->passDaysFromLastNotify(1);
                    $notifySended         = false;

                    if (!$task->fileExist() && $parentOrder['file_name'] && $parentOrder['file_content']) {
                        echo "Try Create Require File\n";
                        $logContent .= "Try Create Require File\n";
                        $domainRoot     = CertumSSLDriver::localAPI()->getDomainRoot($parentOrder['user_id'], array($domain));
                        $domainRootPath = $domainRoot.'/';

                        // File creation mod
                        $fileToCreate   = 'certum.txt';
                        $fileContent    = $parentOrder['file_content'].'-certum.pl';

                        if (!file_exists($domainRootPath."/.well-known/pki-validation/".$fileToCreate)) {
                            if (!file_exists($domainRootPath."/.well-known/pki-validation/")) {
                                mkdir($domainRootPath."/.well-known/pki-validation/", 0777, true);
                            }
                            if (!file_put_contents($domainRootPath."/.well-known/pki-validation/".$fileToCreate, $fileContent)) {
                                echo "File Not Created !\n.";
                                $logContent .= "File Not Created !\n.";
                                if (!empty($adminEmailNotifySend)) {
                                    echo " Sending Admin Email Notification...\n";
                                    $logContent .= " Sending Admin Email Notification...\n";
                                    $adminNotifyFailureSubject = 'Failed create required file';

                                    $adminFailureNotifyMessage = $this->buildAdminNotifyMessage(
                                        $adminNotifyFailureSubject, $clientName, $userEmail, $domain, $parentOrder['order_id'], $parentOrder['used_token']
                                    );
                                    $notification->adminSummary($adminNotifyFailureSubject, $adminFailureNotifyMessage);
                                    $notifySended              = true;
                                }
                            } else {
                                echo "Required File Created Successfully.\n";
                                $logContent .= "Required File Created Successfully.\n";
                                $task->updateFileExist(1);
                                $parentsCertOrders->updateFileCreated($parentOrder['order_id'], 1);
                            }
                        } else {
                            $certificate          = new CertumSSLCertificate();
                            $certificate->userId  = $parentOrder['user_id'];
                            $certificate->orderId = $parentOrder["order_id"];
                            $certificate->verifyDomain($parentOrder['file_name'], $parentOrder['rel_id']);
                            $parentsCertOrders->updateFileCreated($parentOrder["order_id"], 1);
                        }
                    } else {
                        if ($parentOrder['file_name'] == null || $parentOrder['file_content'] == null) {
                            echo "Authentication File Not Exist For This Order.\n";
                            $logContent .= "Authentication File Not Exist For This Order.\n";
                        } else {
                            echo "Required File Exist\n";
                            $logContent .= "Required File Exist\n";
                        }
                    }
                } else {
                    echo "Domain Not Exist.\n";
                    $logContent .= "Domain Not Exist.\n";
                    echo "---End check user domain when he ordering cert---\n";
                    $logContent .= "---End check user domain when he ordering cert---\n";
                }
            }
        } else {
            echo "No files to create! \n";
            $logContent .= "No files to create! \n";
        }
        echo "---End creating required files---\n\n";
        $logContent .= "---End creating required files---\n\n";

        //chet do listy wszystkich niezainstalowanych certów
        $notInstalledOrders = $parentsCertOrders->getAllNotFinishedOrders();

        foreach ($notInstalledOrders as $key => $OrderToInstall) {
            if (!isset($OrderToInstall['domain_id']) && isset($OrderToInstall['parent_id'])) {
                $OrderToInstall = array_merge($OrderToInstall, $parentsCertOrders->getParentParams($OrderToInstall['parent_id']));
            }
            $notInstalledOrders[$key] = $OrderToInstall;
        }

        echo "---Start Installing not installed Certificates---\n\n";
        $logContent .= "---Start Installing not installed Certificates---\n\n";
        foreach ($notInstalledOrders as $notInstalledOrder) {

            if (!empty($notInstalledOrder[0])) {
                foreach ($notInstalledOrder[0] as $key => $val) {
                    $notInstalledOrder[$key] = $val;
                }
                unset($notInstalledOrder[0]);
            }

            $domain         = "";
            $domainRootName = "";
            $notification   = new MGNotification();
            $domainsParams  = CertumSSLDriver::localAPI()->getUserDomains($notInstalledOrder['user_id']);

            echo "User:".$notInstalledOrder['user_id']."\n";
            $logContent .= "User:".$notInstalledOrder['user_id']."\n";
            echo "Order ID:".$notInstalledOrder['order_id']."\n\n";
            $logContent .= "Order ID:".$notInstalledOrder['order_id']."\n\n";

            echo "---Check user domain when he ordering cert---\n";
            $logContent .= "---Check user domain when he ordering cert---\n";
            echo "Domain Name when ordered: ".$notInstalledOrder['domain_id']."\n";
            $logContent .= "Domain Name when ordered: ".$notInstalledOrder['domain_id']."\n";
            echo "User Domains:";
            $logContent .= "User Domains:";

            foreach ($domainsParams as $domainParam) {
                echo $domainParam['domain'].",";
                if ($domainParam['domain'] == $notInstalledOrder['domain_id']) {
                    $domain = $notInstalledOrder['domain_id'];
                }
            }
            echo "\n";
            $logContent .= "\n";

            if ($domain != "") {
                echo "Domain Found\n";
                $logContent .= "Domain Found\n";
                echo "---End check user domain when he ordering cert---\n";
                $logContent .= "---End check user domain when he ordering cert---\n";

                $clientAccount      = new CertumSSLAccount($notInstalledOrder['user_id']);
                $clientAccount->setConnectionParams(null, $notInstalledOrder['rel_id']);
                $orderDetailsParams = array('orderid' => $notInstalledOrder['order_id']);

                $orderDetails = $clientAccount->orderDetails($orderDetailsParams);

                $taskParams         = array();
                $task               = new MGCronTask(array('_tableName' => 'certumssl_cron_tasks'));
                $task->orderId      = $notInstalledOrder['order_id'];
                $task->userId       = $notInstalledOrder['user_id'];
                $task->domainId     = $notInstalledOrder['domain_id'];
                $task->activateDate = '0000-00-00 00:00:00';
                $taskParams         = $task->getTaskByOrderId($notInstalledOrder['order_id']);
                //Tworzy Cron Taska jesli jeszcze nie istnieje
                if (empty($taskParams)) {
                    $task->create();
                }
                $task->updateLastTry();
                //Pobieramy email klienta
                $userAccounts = CertumSSLDriver::localAPI()->getAccounts();
                foreach ($userAccounts as $userAccount) {
                    if ($userAccount['name'] == $notInstalledOrder['user_id']) {
                        $userEmail = $userAccount['email'];
                    }
                }

                foreach ($orderDetails as $orderDetail) {


                    if ($orderDetail["orderdefault"]["orderID"] == $notInstalledOrder['order_id'] && isset($orderDetail['cert']['X509Cert'])) {
                        echo "---Try Install---\n";
                        $logContent .= "---Try Install---\n";
                        $certyficateParams  = array('orderID' => $notInstalledOrder['order_id']);
                        $certyficateDetails = $clientAccount->certficateDetails($certyficateParams);
                        if ($certyficateDetails) {

                            $installCrt = "Error";
                            $CRT        = $certyficateDetails->certificateDetails->X509Cert;
                            $CRT_CA     = "";
                            foreach ($certyficateDetails->caBundle->X509Cert as $caBundle) {
                                $CRT_CA .= $caBundle."\n";
                            }

                            if ($CRT != null) {
                                $installCrt = CertumSSLDriver::localAPI()->installCrt($notInstalledOrder['user_id'],
                                    array('crt' => $CRT, 'cabundle' => $CRT_CA, 'key' => $notInstalledOrder['csr_key'], 'domain' => $domain));
                            }

                            if (!empty($installCrt['cpanelresult']['error']) || $installCrt == "Error") {
                                $adminEmailNotifySend = array();
                                $adminEmailNotifySend = $task->passDaysFromLastNotify(1);
                                $error                = isset($installCrt['cpanelresult']['error']) ? $installCrt['cpanelresult']['error'] : $installCrt;
                                echo "Error: ".$error."\n";
                                $logContent .= "Error: ".$error."\n";
                                //Jeśli minoł dzień od ostatniego wysłania to wyśle ponownie
                                if (!empty($adminEmailNotifySend)) {
                                    echo "Send Admin Notifiaction : Failed install certyficate\n";
                                    $logContent .= "Send Admin Notifiaction : Failed install certyficate\n";
                                    $adminNotifyFailureSubject = 'Failed install certyficate';

                                    $adminFailureNotifyMessage = $this->buildAdminNotifyMessage(
                                        $adminNotifyFailureSubject, $notInstalledOrder['user_id'], $userEmail, $domain, $notInstalledOrder['order_id'], $notInstalledOrder['used_token'], $error
                                    );
                                    $notification->adminSummary($adminNotifyFailureSubject, $adminFailureNotifyMessage);
                                    $notifySended              = true;
                                }
                            } else {
                                // Ustawia order na Finished/installed
                                if ($notInstalledOrder['order_id'][0] == '_' && $notInstalledOrder['order_id'][strlen($notInstalledOrder['order_id']) - 1] == '_') {
                                    $reissueOrders = new MGReissuedOrders(array('_tableName' => 'certumssl_reissued_orders', 'orderId' => $notInstalledOrder['order_id']));
                                    $reissueOrders->setFinished(1);
                                } else {
                                    $parentOrder = new MGCertOrders(array('_tableName' => 'certumssl_orders', 'orderId' => $notInstalledOrder['order_id']));
                                    $parentOrder->setFinished(1);
                                }
                                echo "Installed\n";
                                $logContent .= "Installed\n";
                                $adminNotifySubject = MGLang::T('raportTitle');
                                //Success Certfikat został zainstalowany i trzeba wysłać email do klienta
                                try {
                                    $notification->userSuccessInstallCertificate($userEmail, array('{$domain}', '{$certificate_id}', '{$voucher_code}'),
                                        array($domain, $notInstalledOrder['order_id'], $notInstalledOrder['used_token']));
                                    $adminNotifyMessage = $this->buildAdminNotifyMessage(
                                        $adminNotifySubject, $clientName, $userEmail, $domain, $notInstalledOrder['order_id'], $notInstalledOrder['used_token'], null, 'success'
                                    );
                                    // Ustawia Cron Task na Finished
                                    $notification->adminSummary($adminNotifySubject, $adminNotifyMessage);
                                    $task->userId       = $notInstalledOrder['user_id'];
                                    $task->domainId     = $notInstalledOrder['domain_id'];
                                    $task->activateDate = date('Y-m-d H:i:s');
                                    $task->setFinished();
                                    echo "Email Success Seded to Client.\n";
                                    $logContent .= "Email Success Seded to Client.\n";
                                } catch (Exception $ex) {
                                    MGExceptionLogger::addLog(null, null, $ex);
                                }
                            }
                            if ($notifySended) {
                                $task->updateAdminNotifyDate();
                            }
                        }
                    }
                }
            } else {
                echo "Domain Not Exist\n";
                $logContent .= "Domain Not Exist\n";
                echo "---End check user domain when he ordering cert---\n";
                $logContent .= "---End check user domain when he ordering cert---\n";
            }
        }
        echo "---End Installing not installed Certificates---\n\n";
        $logContent .= "---End Installing not installed Certificates---\n\n";
        echo "---Cron Finished---";
        $logContent .= "---Cron Finished---";
        $handle = fopen("cron_log.txt", "a+");
        fwrite($handle, $logContent);
        fclose($handle);
    }

    function buildAdminNotifyMessage($title, $clientName, $clientEmail, $clientDomain, $cerumsslOrderId, $voucherCode, $errorMessage = null, $type = 'failure')
    {

        if ($type == 'success') {
            $adminNotifyMessage = "<html>
                <head>
                    <title>".$title."</title>
                </head>
                <body>
                <h4>{$clientName} successfully installed certyficate</h4>
                    On Domain: <b>{$clientDomain}</b>, <br>
                    Certum SSL Order ID: <b>{$cerumsslOrderId}</b>,<br>
                    Used Voucher Code: <b>{$voucherCode}</b> ,<br>
                    Client Email: <b>{$clientEmail}
                </body>
            </html>";
        } else {
            $adminNotifyMessage = "<html>
                <head>
                    <title>".$title."</title>
                </head>
                <body>
                <h4>Failed create required file for domain:{$clientDomain}</h4>

                    Details:<br>
                    Client: <b>{$clientName}</b>, <br>
                    Client Email: <b>{$clientEmail}</b>, <br>
                    Certum SSL Order ID: <b>{$cerumsslOrderId}</b>,<br>
                    Used Voucher Code: <b>{$voucherCode}</b> ,<br>";
            if ($errorMessage) {
                $adminNotifyMessage .= "Recived Error Message: ".$errorMessage;
            }
            $adminNotifyMessage .=
                "</body>
            </html>";
        }
        return $adminNotifyMessage;
    }
}
