CREATE TABLE IF NOT EXISTS `certumssl_configuration` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(40) NOT NULL,
  `value` text,
  `relid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `certumssl_cron_tasks` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rel_id` int(11) DEFAULT NULL,
  `user_id` varchar(40) DEFAULT NULL,
  `order_id` varchar(255) NOT NULL,
  `domain_id` varchar(40) DEFAULT NULL,
  `create_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activate_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_try_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `admin_failnotify_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `file_exist` int(1) NOT NULL DEFAULT '0',
  `verify_domain_sended` int(11) NOT NULL DEFAULT '0',
  `finished` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;
    
CREATE TABLE IF NOT EXISTS `certumssl_api_logs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` datetime NOT NULL,
  `request` text,
  `response` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `certumssl_orders` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rel_id` int(11) DEFAULT NULL,
  `order_id` varchar(255) NOT NULL,
  `user_id` varchar(120) NOT NULL,
  `domain_id` varchar(120) NOT NULL,
  `used_voucher` varchar(60) NOT NULL,
  `used_csr` text NOT NULL,
  `csr_key` text NOT NULL,
  `crt` text,
  `details` text,
  `file_name` text,
  `file_content` text,
  `status` varchar(20) DEFAULT NULL,
  `file_created` int(10) DEFAULT '0',
  `Finished` int(10) DEFAULT '0',
  `voucher_activate_date` datetime NOT NULL,
  `date` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `certumssl_users_uniqid` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` varchar(120) NOT NULL,
  `unique_id` varchar(120) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `certumssl_reissued_orders` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` varchar(255) NOT NULL,
  `parent_id` varchar(255) DEFAULT NULL,
  `Finished` int(10) DEFAULT '0',
  `date` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;
    
INSERT INTO `certumssl_configuration` (`name`, `value`, `relid`) VALUES
('email', 'test@admin.com', 0),
('sender', 'noreply@example.com', 0),
('success_email_subject', 'Successfull Certyficate instalation', 0),
('success_email_message', 'On Domain:{$domain},\r\nOrderID: {$certificate_id},\r\nUsed Voucher Code: {$voucher_code}', 0),
('failure_email_subject', 'Failed Certyficate instalation', 0),
('failure_email_message', 'On Domain:{$domain},\norderID: {$certificate_id},\nUsed Voucher Code: {$voucher_code}', 0),
('apilogs_turnon_value', 'off', 0),
('api_login', '', 1),
('api_password', '', 1),
('api_wsdl_url', 'https://213.222.200.154/service/PartnerApi?wsdl', 1),
('api_wsdl_lang', 'en', 1),
('billing_url', 'http://example.com/whmcs/',0),
('logs_limit', '1000',0);